﻿Version=6.90
NumberOfForms=0
NumberOfObjects=3
Object1=Command:Command
Object2=Connection:Connection
Object3=Data:DataReader
Sub designer
end sub
@EndOfDesignText@
'(****************************************************************************************)
'(* Project : Demo-Programm for SQLite 3 under Windows Mobile™                           *)
'(* SQLSyntx: SQLite 3 for Windows Mobile                                                *)
'(* ExeName : SQL-Unit.EXE                                                               *)
'(* Unit    : SQL.BAS - Funktionsmodul für die Bearbeitung von SQL Lite 3-Datenbanken    *)
'(* Compiler: Basic4PPC V6.90 - Net Framework CF2                                        *)
'(* Datum   : 10.06.2010                                                                 *)
'(* durch   : BNG                                                                        *)
'(*                                                                                      *)
'(*  © 05/2010 by esdaS© ESPRIT DATA SOFTWARE, Oberhausen (Rhld.) - http://www.esdaso.de *)
'(*  ® Autor: Bodo-Norbert Göldner - goeldner@esdaso.de                                  *)
'(*                                                                                      *)
'(****V1.0.0.1****************************************************************************)

Sub Globals
	Dim Values(0) As String
	Dim Content(0) As String
	Dim SpNam(0) As String
	Dim SelSpNam(0) As String
	Dim SpTyp(0) As String
	Dim SelSpTyp(0) As String
	Dim SpNull(0) As String
	Dim SpDefault(0) As String
	Dim SpPk(0) As String
End Sub

Public Sub CreateConnection(DatabaseFile, Password)
	DatabaseCreate = False
	If FileExist(DatabaseFile) = False Then
		DatabaseCreate = True
	End If
	Connection.New1
	Command.New1("", Connection.Value)
	If StrLength(Password) = 0 Then
		Connection.Open("Data SOURCE = " & DatabaseFile)
	Else
		Connection.Open2("Data SOURCE = " & DatabaseFile, Password)
	End If
	Data.New1
	Return DatabaseCreate
End Sub

Public Sub CloseConnection(DatabaseFile)
	Result = False
	If Main.DBConnect = True Then
		Connection.Close
		Data.Close
		Result = True
	End If
	Return Result
End Sub

Public Sub CreateTableIfNotExists(DatabaseCreate, Password)
	Result = False
	If DatabaseCreate = True Then
		CreateDataTable("t_lizenz", "ID|Anwender|eMail|OrderBy|LizenzNo|IMEI|DateTimeStamp", "INTEGER PRIMARY KEY|TEXT|TEXT|TEXT|TEXT|TEXT|TEXT")
		SetDatabasePassword(Password)
		Result = True
	End If
	Return Result
End Sub

Public Sub CreateDataTable(DataTable, Fields, Contents)
	Connection.BeginTransaction
	Values() = StrSplit(Fields, "|")
	Content() = StrSplit(Contents, "|")
	Fields = ""
	For I = 0 To ArrayLen(Values()) - 1
		Fields = Fields & Values(I) & " " & Content(I) & ", "
	Next
	Fields = StrRemove(Fields, StrLength(Fields) - 2, 2)
	Command.CommandText = "SELECT name FROM sqlite_master WHERE type = 'table' AND name='" & DataTable & "'" 
	Data.Value = Command.ExecuteReader
	If Data.ReadNextRow = False Then
		Data.Close
		Command.CommandText = "CREATE TABLE " & DataTable & " (" & Fields & ")"
		Command.ExecuteNonQuery
		Connection.EndTransaction
	Else
		Data.Close
	End If
End Sub

Public Sub GetSQLParams(Info, DataTable)	' Zur Verfügung gestellt durch: berndgoedecke, Basic4PPC-Forum
	Connection.BeginTransaction
	Command.CommandText = "PRAGMA TABLE_INFO ('" & DataTable & "')"
	Data.Value = Command.ExecuteReader
	ReadNextRow = Data.ReadNextRow
	If ReadNextRow = True Then
		Do While ReadNextRow = True
			SpNamStr = SpNamStr & Data.GetValue(1) & "|"
			SpTypStr = SpTypStr & Data.GetValue(2) & "|"
			SpNullStr = SpNullStr & Data.GetValue(3) & "|"
			SpDefaultStr = SpDefaultStr & Data.GetValue(4) & "|"
			SpPkStr = SpPkStr & Data.GetValue(5) & "|"
			ReadNextRow = Data.ReadNextRow
		Loop
		SpNamStr = SubString(SpNamStr, 0, StrLength(SpNamStr) - 1)
		SpTypStr = SubString(SpTypStr, 0, StrLength(SpTypStr) - 1)
		SpNullStr = SubString(SpNullStr, 0, StrLength(SpNullStr) - 1)
		SpDefaultStr = SubString(SpDefaultStr, 0, StrLength(SpDefaultStr) - 1)
		SpPkStr = SubString(SpPkStr, 0, StrLength(SpPkStr ) - 1)
		SpNam() = StrSplit(SpNamStr, "|")
		SelSpNam() = StrSplit(SpNamStr, "|")
		SpTyp() = StrSplit(SpTypStr, "|")
		SelSpTyp() = StrSplit(SpTypStr, "|")
		SpNull() = StrSplit(SpNullStr, "|")
		SpDefault() = StrSplit(SpDefaultStr, "|")
		SpPk() = StrSplit(SpPkStr, "|")
		DebStr = SpNamStr & CRLF & SpTypStr & CRLF & SpNullStr & CRLF & SpDefaultStr
		SpAnz = ArrayLen(SpNam())
		' Rückgabe-Wert angepasst durch: BNG
		Select Info 
			Case 1: Result = SpNamStr
			Case 2: Result = SpTypStr
			Case 3: Result = SpNullStr
			Case 4: Result = SpDefaultStr
			Case 5: Result = SpPkStr
			Case 6: Result = DebStr
			Case 7: Result = SpAnz
		End Select
	End If
	Data.Close
	Connection.EndTransaction
	Return Result
End Sub

Public Sub SetDatabasePassword(Password)
	If (Main.DBConnect = True) AND (StrLength(Password) > 0) Then
		Connection.BeginTransaction
		Connection.ChangePassword(Password)
		Connection.EndTransaction
	End If
End Sub

Public Sub GetColumnsCount(DataTable)
	Return GetSQLParams(7, DataTable)
End Sub

Public Sub GetTableCount(DataTable)
	Connection.BeginTransaction
	Command.CommandText = "SELECT COUNT(*) FROM " & DataTable
	Data.Value = Command.ExecuteReader
	Result = -1
	If Data.ReadNextRow = True Then
		Result = Data.GetValue(0)
	End If
	Data.Close
	Connection.EndTransaction
	Return Result
End Sub

Public Sub DatabaseReorganization(DataTable)
	Records = GetTableCount(DataTable)
	ColumnsCount = GetSQLParams(7, DataTable)
	If ColumnsCount > 0 Then
		Values() = StrSplit(GetSQLParams(2, DataTable), "|")
		For I = 0 To ArrayLen(SpNam()) - 1
			Fields = Fields & "|"	& SpNam(I)
		Next
		For I = 0 To ArrayLen(SpTyp()) - 1
			If I = 0 Then
				Contents =  "INTEGER PRIMARY KEY|"
			Else
				Contents = Contents & SpTyp(I) & "|"
			End If
		Next
		Fields = StrRemove(Fields, 0, 1)
		Contents = StrRemove(Contents, StrLength(Contents) - 1, 1)
		CreateDataTable("t_temp", Fields, Contents)
		For I = 1 To Records
			Record = ReadDataRecord(DataTable, I)
			If StrLength(Record) > 0 Then
				SaveDataRecord("t_temp", 0, I, Fields, Record)
			End If
		Next
		Connection.BeginTransaction
		Command.CommandText = "DROP TABLE " & DataTable
		Data.Value = Command.ExecuteReader
		Data.Close
		Connection.EndTransaction
		CreateDataTable(DataTable, Fields, Contents)
		For I = 1 To Records
			SaveDataRecord(DataTable, 0, I, Fields, ReadDataRecord("t_temp", I))
		Next
		Connection.BeginTransaction
		Command.CommandText = "DROP TABLE t_temp"
		Data.Value = Command.ExecuteReader
		Data.Close
		Connection.EndTransaction
	End If
End Sub

Public Sub ReadDataRecord(DataTable, ID)
	Result = ""
	ColumnsCount = GetSQLParams(7, DataTable)
	If ColumnsCount > 0 Then
		Connection.BeginTransaction
		Command.AddParameter("ID")
		Command.SetParameter("ID", ID)
		Command.CommandText = "SELECT * FROM " & DataTable & " WHERE ID=@ID"
		Data.Value = Command.ExecuteReader
		If Data.ReadNextRow = True Then
			For I = 1 To ColumnsCount - 1
				Result = Result & Data.GetValue(I) & "|"
			Next
			Result = StrRemove(Result, StrLength(Result) - 1, 1)
		End If
		Data.Close
		Connection.EndTransaction
	End If
	Return Result
End Sub

Public Sub SaveDataRecord(DataTable, Mode, ID, Fields, Contents)
	Content() = StrSplit(Contents, "|")
	Values() = StrSplit(Fields, "|")
	For I = 0 To ArrayLen(Values()) - 1
		If Mode = 0 Then
			Fields1 = Fields1 & "," & Values(I)
			If I = 0 Then
				Fields2 = "null"
			Else
				Fields2 = Fields2 & ",@" & Values(I)
			End If
		Else
			Fields1 = Fields1 & Values(I) & "=@" & Values(I) & ", "
		End If
	Next
	If Mode = 0 Then
		CommandText = "INSERT INTO " & DataTable & " (" & StrRemove(Fields1, 0, 1) & ") VALUES (" & Fields2 & ")"
	Else
		CommandText = "UPDATE " & DataTable & " SET " & StrRemove(Fields1, StrLength(Fields1) - 2, 2) & " WHERE ID=@ID"
		Command.AddParameter("ID")
		Command.SetParameter("ID", ID)
	End If
	Connection.BeginTransaction
	For I = 0 To ArrayLen(Content()) - 1
		Command.AddParameter(Values(I + 1))
		Command.SetParameter(Values(I + 1), Content(I))
	Next
	Command.CommandText = CommandText
	Command.ExecuteNonQuery
	Connection.EndTransaction
End Sub

Public Sub DeleteDataRecord(DataTable, ID, ReOrganisation)
	Connection.BeginTransaction
	Command.AddParameter("ID")
	Command.SetParameter("ID", ID)
	Command.CommandText = "DELETE FROM " & DataTable & " WHERE ID=@ID"
	Command.ExecuteNonQuery
	Connection.EndTransaction
	If (ReOrganisation = True) AND (GetTableCount(DataTable) > 0) Then
		DatabaseReorganization(DataTable)
	End If
End Sub